## libfiu 0.95

=== libfiu/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 $(CFLAGS)

# Optimization CFLAGS, only used when doing a non-debug build.
OPT_CFLAGS = -O3

ifdef DEBUG
    ALL_CFLAGS += -g
else
   ifdef PROFILE
        ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
   else
       ALL_CFLAGS += $(OPT_CFLAGS)
   endif
endif

ifdef TRACE
    ALL_CFLAGS += -DFIU_TRACE=1
endif

# prefix for installing the binaries
PREFIX=/usr/local

# prefix for eventual location of binaries
DESTDIR=$(PREFIX)

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


OBJS = fiu.o fiu-rc.o backtrace.o wtable.o hash.o


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
else
	NICE_CC = $(CC)
endif

LIB_VER=0.95
LIB_SO_VER=0


# We attempt to detect if we have the extensions we use in backtrace.c by just
# attempting to compile it normally, and fall back to the dummy version if
# that fails. Not very sophisticated but should be safe.
USE_DUMMY_BACKTRACE := $(shell $(CC) $(ALL_CFLAGS) -c backtrace.c \
	-o backtrace-check.o || echo -DDUMMY_BACKTRACE)
ifndef USE_DUMMY_BACKTRACE
# The real backtrace needs linking against libdl.
USE_LIBDL = -ldl
endif


default: all

all: libs libfiu.pc

libfiu.pc: build-flags libfiu.pc.in
	@echo "generating libfiu.pc"
	@cat libfiu.pc.in | \
		sed 's@++DESTDIR++@$(DESTDIR)@g' | \
		sed 's@++LIB_VER++@$(LIB_VER)@g' \
		> libfiu.pc

libs: libfiu.so libfiu.a

libfiu.so: build-flags symbols.map fiu.h $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC \
		-Wl,-soname,libfiu.so.$(LIB_SO_VER) \
		-Wl,--version-script=symbols.map \
		$(OBJS) -lpthread $(USE_LIBDL) -o libfiu.so.$(LIB_VER)
	ln -fs libfiu.so.$(LIB_VER) libfiu.so
	ln -fs libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER)

libfiu.a: build-flags fiu.h $(OBJS)
	$(AR) cr libfiu.a $(OBJS)


install-lib: libs libfiu.pc
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 libfiu.so.$(LIB_VER) $(PREFIX)/lib
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(INSTALL) -m 0755 libfiu.a $(PREFIX)/lib
	$(INSTALL) -d $(PREFIX)/include
	$(INSTALL) -m 0644 fiu.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-control.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-local.h $(PREFIX)/include
	$(INSTALL) -d $(PREFIX)/lib/pkgconfig
	$(INSTALL) -m 644 libfiu.pc $(PREFIX)/lib/pkgconfig
	@echo
	@echo "Please run ldconfig to update your library cache"
	@echo

install-man:
	$(INSTALL) -d $(PREFIX)/share/man/man3
	$(INSTALL) -m 0644 libfiu.3 $(PREFIX)/share/man/man3/

install: install-lib install-man

uninstall-lib:
	$(RM) $(PREFIX)/lib/libfiu.so
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_VER)
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(RM) $(PREFIX)/lib/libfiu.a
	$(RM) $(PREFIX)/include/fiu.h
	$(RM) $(PREFIX)/include/fiu-control.h
	$(RM) $(PREFIX)/include/fiu-local.h
	$(RM) $(PREFIX)/lib/pkgconfig/libfiu.pc

uninstall-man:
	$(RM) $(PREFIX)/share/man/man3/libfiu.3

uninstall: uninstall-lib uninstall-man


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi


$(OBJS): build-flags

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

backtrace.o: ALL_CFLAGS += $(USE_DUMMY_BACKTRACE)


doxygen:
	        $(MAKE) LIB_VER=$(LIB_VER) -C doxygen


clean:
	rm -f libfiu.pc $(OBJS) backtrace-check.o
	rm -f libfiu.so libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER) libfiu.a
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
	$(MAKE) -C doxygen $@

.PHONY: default all libs \
	install-lib install-man install \
	uninstall-lib uninstall-man uninstall \
	doxygen clean \
	.force-build-flags

=== tests/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall
ALL_CFLAGS = -I../libfiu/ -L../libfiu/ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../libfiu/
	NICE_PY = @echo "  PY  $<"; ./wrap-python 2
	NICE_LN = @echo "  LN $@"; ln -f
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH=../libfiu/
	NICE_PY = ./wrap-python 2
	NICE_LN = ln -f
endif

default: tests

all: tests

tests: c-tests py-tests gen-tests utils-tests collisions-tests


# Link the libraries to a single place, some of the tests need this.
libs:
	mkdir -p libs/

libs/fiu_posix_preload.so: ../preload/posix/fiu_posix_preload.so libs
	$(NICE_LN) $< libs/

libs/fiu_run_preload.so: ../preload/run/fiu_run_preload.so libs
	$(NICE_LN) $< libs/

lnlibs: libs/fiu_posix_preload.so libs/fiu_run_preload.so


#
# C tests
#

C_SRCS := $(wildcard test-*.c)
C_OBJS := $(patsubst %.c,%.o,$(C_SRCS))
C_BINS := $(patsubst %.c,%,$(C_SRCS))

c-tests: $(patsubst %.c,c-run-%,$(C_SRCS))

test-%: test-%.c build-flags
	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -lpthread -o $@

# Tests that use the stack need special build flags, as some common
# optimizations can cause them to fail.
# -rdynamic: Adds all symbols to the dynamic symbol table. This option is
#    needed for backtrace() to work properly.
# -fno-optimize-sibling-calls: This optimization can turn some calls into
#    direct jumps, which leaves caller information out of the stack frame and
#    makes functions not appear in the backtrace. We disable it.
test-enable_stac%: test-enable_stac%.c build-flags
	$(NICE_CC) $(ALL_CFLAGS) \
		-rdynamic -fno-optimize-sibling-calls $< -lfiu -lpthread -o $@

c-run-%: %
	$(NICE_RUN) ./$<


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi


#
# Python tests
#

PY_TESTS := $(wildcard test-*.py)

py-tests: $(patsubst %.py,py-run-%,$(PY_TESTS))

py-run-%: %.py lnlibs small-cat
	$(NICE_PY) ./$<

small-cat: small-cat.c
	$(NICE_CC) $(ALL_CFLAGS) $< -o $@

#
# Sub-directory tests
#

gen-tests:
	$(MAKE) -C generated

utils-tests:
	$(MAKE) -C utils

collisions-tests:
	$(MAKE) -C collisions

#
# Cleanup
#

# Normally, $C_OBJS and $C_BINS are removed by make after building,
# since here they're considered "intermediate files"; however we
# also remove them when cleaning just in case.
clean:
	rm -f $(C_OBJS) $(C_BINS)
	rm -rf libs/ small-cat
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
	$(MAKE) -C generated clean

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests gen-tests utils-tests \
	.force-build-flags

=== preload/posix/Makefile ===

CFLAGS += -std=c99 -Wall -O3
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
		-D_LARGEFILE64_SOURCE=1 -I. -I../../libfiu/ \
		$(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifdef POSIX_TRACE
    ALL_CFLAGS += -DFIU_POSIX_TRACE=1
endif


# prefix for installing the binaries
PREFIX=/usr/local

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


MODS = $(sort $(wildcard modules/*.mod))
GEN_C = $(addsuffix .c,$(MODS))
GEN_OBJS = $(addsuffix .o,$(MODS))
GEN_FL = $(addsuffix .fl,$(MODS))
CUSTOM_OBJS = $(patsubst %.c,%.o,$(sort $(wildcard modules/*.custom.c)))
OBJS = codegen.o $(GEN_OBJS) $(CUSTOM_OBJS)


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_GEN = @echo "  GEN $@"; ./generate
	Q = @
else
	NICE_CC = $(CC)
	NICE_GEN = ./generate
	Q =
endif


default: all
	
all: fiu_posix_preload.so function_list

BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

$(GEN_OBJS): $(GEN_C)

$(OBJS): build-flags codegen.h

%.mod.c: %.mod
	$(NICE_GEN) $< $@ $<.fl

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

# We define _GNU_SOURCE to get RTLD_NEXT if available; on non-GNU
# platforms it should be harmless.
codegen.o: codegen.c build-flags build-env.h
	$(NICE_CC) $(ALL_CFLAGS) -D_GNU_SOURCE -c $< -o $@

# some platforms do not have libdl, we only use it if available
build-needlibdl:
	@$(LD) -ldl -o dlcheck.so 2>/dev/null \
		&& echo -ldl > $@ || echo > $@
	@rm -f dlcheck.so

# libc's soname depends on the platform (most use libc.so.6, but for example
# ia64 and alpha use libc.so.6.1), so find which one to use at build-time.
# Please note that the argument to ldd *must* start with "./", otherwise some
# "ldd"s won't work (for example, the one in FreeBSD 8.1).
build-libcsoname:
	@$(CC) -x c /dev/null -lc -shared -o build-libccheck.so
	@ldd ./build-libccheck.so | grep libc.so | awk '{ print $$1 }' > $@
	@rm build-libccheck.so
	@test "`cat $@`" != "" || \
		(echo "Error finding soname, please report"; rm $@; exit 1)

build-env.h: build-env.h.in build-libcsoname
	@echo "  GEN $@"
	$(Q) sed "s+@@LIBC_SONAME@@+`cat build-libcsoname`+g" build-env.h.in \
		> build-env.h


fiu_posix_preload.so: build-flags build-env.h build-needlibdl $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) \
		-L../../libfiu/ \
		-lfiu `cat build-needlibdl` \
		-o fiu_posix_preload.so


# this should only be needed when building the function list and not the
# preload library
%.mod.fl: %.mod
	$(NICE_GEN) $< $<.c $@

function_list: $(GEN_FL) function_list.in
	@echo "  function_list"
	$(Q) cp function_list.in function_list
	$(Q) for i in $(GEN_FL); do cat $$i >> function_list; done

install: fiu_posix_preload.so
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 fiu_posix_preload.so $(PREFIX)/lib

uninstall:
	$(RM) $(PREFIX)/lib/fiu_posix_preload.so

clean:
	rm -f $(OBJS) $(GEN_OBJS:.o=.c) $(GEN_FL)
	rm -f build-flags build-env.h build-libcsoname build-needlibdl
	rm -f function_list fiu_posix_preload.so
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out
	rm -f modules/*.bb modules/*.bbg modules/*.da
	rm -f modules/*.gcov modules/*.gcda modules/*.gcno modules/gmon.out

.PHONY: default install uninstall clean .force-build-flags

=== tests/generated/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall
ALL_CFLAGS = -I../../libfiu/ -L../../libfiu/ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; \
		   LD_LIBRARY_PATH=../../libfiu/ \
		   LD_PRELOAD="../../preload/run/fiu_run_preload.so \
		   	../../preload/posix/fiu_posix_preload.so"
	NICE_GEN = @echo "  GEN $@"; ./generate-test
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH=../../libfiu/ \
		   LD_PRELOAD="../../preload/run/fiu_run_preload.so \
		   	../../preload/posix/fiu_posix_preload.so"
	NICE_GEN = ./generate-test
endif

default: tests

all: tests


CONF := $(wildcard tests/*.conf)
GEN_BIN := $(patsubst %.conf,%.bin,$(CONF))

tests: $(patsubst %,%-run,$(GEN_BIN))

%-run: %
	$(NICE_RUN) ./$<

# .bin from .c
%.bin: %.c build-flags
	$(NICE_CC) $(ALL_CFLAGS) $< -lfiu -o $@

# .c from .conf
%.c: %.conf generate-test
	$(NICE_GEN) -c $< -o $@

# Useful for manually generating the C-files, that otherwise get deleted as
# intermediates.
c-files: $(patsubst %.conf,%.c,$(CONF))


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi


#
# Cleanup
#

clean:
	rm -f $(GEN_BIN) $(patsubst %.bin,%.c,$(GEN_BIN))
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests \
	.force-build-flags

=== tests/utils/Makefile ===

ifneq ($(V), 1)
	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../../libfiu/
	NICE_LN = @echo "  LN $@"; ln -f
else
	NICE_RUN = LD_LIBRARY_PATH=../../libfiu/
	NICE_LN = ln -f
endif


default: all

all: lnlibs tests


# Link the libraries to a single place, as the scripts expect.
libs:
	mkdir -p libs/

libs/fiu_posix_preload.so: ../../preload/posix/fiu_posix_preload.so libs
	$(NICE_LN) $< libs/

libs/fiu_run_preload.so: ../../preload/run/fiu_run_preload.so libs
	$(NICE_LN) $< libs/

lnlibs: libs/fiu_posix_preload.so libs/fiu_run_preload.so


#
# Tests
#

SRCS := $(wildcard test-*)

tests: $(patsubst %,run-%,$(SRCS))

run-%: %
	$(NICE_RUN) ./$< > output-$<.txt 2>&1


#
# Cleanup
#

clean:
	rm -f libs/*.so output-*.txt
	rmdir libs/

.PHONY: default all clean \
	tests lnlibs

=== debian/changelog ===
libfiu (0.95-4build1) artful; urgency=medium

  * No change rebuild to drop Python 3.5 support.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 04 Aug 2017 16:25:54 +1200

libfiu (0.95-4) unstable; urgency=medium

  * Apply patch from Steve Langasek via Ubuntu to fix autopkgtests by using
    double quotes to survive the parser and by setting allow-stderr to account
    for the error message from ls. (Closes: #869709)

 -- Chris Lamb <lamby@debian.org>  Tue, 25 Jul 2017 21:51:44 +0100

libfiu (0.95-3) unstable; urgency=medium

  * Use /bin/ls over "ls" in autopkgtest.

 -- Chris Lamb <lamby@debian.org>  Fri, 18 Nov 2016 09:47:22 +0100

libfiu (0.95-2) unstable; urgency=medium

  * Expand the autopkgtest tests from upstram's suggestions.

 -- Chris Lamb <lamby@debian.org>  Thu, 17 Nov 2016 18:44:36 +0100

libfiu (0.95-1) unstable; urgency=medium

  * New upstream release.
  * All patches now applied upstream.
  * Move to DEP-5 debian/copyright format.

 -- Chris Lamb <lamby@debian.org>  Thu, 17 Nov 2016 16:10:15 +0100

libfiu (0.94-10) unstable; urgency=medium

  * Add a simple autopkgtest smoke test.

 -- Chris Lamb <lamby@debian.org>  Sun, 13 Nov 2016 10:09:27 +0000

libfiu (0.94-9) unstable; urgency=medium

  * Run "gbp pq import && gpq pq export" to refresh patches.
  * Add 0003-Sort-modules-to-ensure-reproducible-order-in-binary.patch to try
    to ensure a reproducible build for modules.

 -- Chris Lamb <lamby@debian.org>  Sun, 23 Oct 2016 13:30:26 +0200

libfiu (0.94-8) unstable; urgency=medium

  * Fix FTBFS under bash due to lack of '&&' in debian/rules.

 -- Chris Lamb <lamby@debian.org>  Thu, 20 Oct 2016 16:29:51 +0200

libfiu (0.94-7) unstable; urgency=medium

  * Actually drop /usr/lib/libfiu.so symlink in libfiu0 package.
    (Closes: #828828)

 -- Chris Lamb <lamby@debian.org>  Wed, 29 Jun 2016 14:59:41 +0200

libfiu (0.94-6) unstable; urgency=medium

  * Drop /usr/lib/libfiu.so symlink in libfiu0 package and add override.
    (Closes: #828828)

 -- Chris Lamb <lamby@debian.org>  Tue, 28 Jun 2016 10:51:01 +0200

libfiu (0.94-5) unstable; urgency=medium

  * Bump Standards-Version to 3.9.8.
  * Install /usr/lib/libfiu.so symlink to appease lintian.

 -- Chris Lamb <lamby@debian.org>  Mon, 27 Jun 2016 17:32:42 +0200

=== debian/control ===
Source: libfiu
Section: libs
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-python,
 python-all-dev,
 python-docutils,
 python3-all-dev
Standards-Version: 3.9.8
Homepage: http://blitiri.com.ar/p/libfiu/
Vcs-Git: https://github.com/lamby/pkg-libfiu
Vcs-Browser: https://github.com/lamby/pkg-libfiu

Package: libfiu0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: userspace fault injection framework
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the libfiu shared library. To perform fault injection,
 you will require the "libfiu-dev" package.

Package: fiu-utils
Section: devel
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: userspace fault injection framework (utilities)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the fiu-run, fiu-ls and fiu-ctrl utilities.

Package: libfiu-dev
Section: libdevel
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: userspace fault injection framework (development libraries)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the development libraries and documentation in HTML and
 reStructuredText formats.

Package: python-fiu
Section: python
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Description: userspace fault injection framework (Python bindings)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains Python bindings to libfiu.

Package: python3-fiu
Section: python
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Description: userspace fault injection framework (Python 3 bindings)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains Python 3 bindings to libfiu.

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
PYTHON2_VERSIONS := $(shell pyversions -sv)
PYTHON3_VERSIONS := $(shell py3versions -sv)

%:
	dh $@ --with python3,python2

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build -- V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON2_VERSIONS); do \
	  python$$i ./setup.py build; \
	done
	cd bindings/python && \
	set -e && for i in $(PYTHON3_VERSIONS); do \
	  python$$i ./setup.py build; \
	done

override_dh_auto_test:
	dh_auto_test -- V=1 LC_ALL=C

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu
	cd bindings/python && \
	set -e && for i in $(PYTHON2_VERSIONS); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb; \
	done
	cd bindings/python && \
	set -e && for i in $(PYTHON3_VERSIONS); do \
	  python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst

=== debian/tests/control ===
# Test that fiu-run executes, without blocking the C call.
Depends: @
Test-Command: fiu-run -x -c 'enable name=posix/io/*' /bin/true

# Test that fiu-run actually blocks the C call.
Depends: @
Restrictions: allow-stderr
Test-Command: ! fiu-run -x -c "enable name=posix/io/*" /bin/ls

# Smoke test the Python 2 module.
Depends: @
Test-Command: python -c "import fiu; fiu.enable(\"p1\"); assert fiu.fail(\"p1\")"

# Smoke test the Python 3 module.
Depends: @
Test-Command: python3 -c "import fiu; fiu.enable(\"p1\"); assert fiu.fail(\"p1\")"

=== debian/watch ===
version=3
http://blitiri.com.ar/p/libfiu/ files/[^/]+/libfiu-(.*).tar.gz

## libfiu 0.96

=== libfiu/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.95
+LIB_VER=0.96
 LIB_SO_VER=0

=== tests/utils/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 default: all
 
-all: lnlibs tests
+all: tests
 
 
 # Link the libraries to a single place, as the scripts expect.
@@ -34,7 +34,7 @@
 
 tests: $(patsubst %,run-%,$(SRCS))
 
-run-%: %
+run-%: % lnlibs
 	$(NICE_RUN) ./$< > output-$<.txt 2>&1

=== debian/changelog ===
libfiu (0.96-4build1) disco; urgency=medium

  * No-change rebuild to build without python3.6 support.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 03 Nov 2018 12:07:38 +0000

libfiu (0.96-4) unstable; urgency=medium

  * Apply upstream patch to make the build more robust against --as-needed.
    (Closes: #902363)

 -- Chris Lamb <lamby@debian.org>  Sat, 30 Jun 2018 20:55:15 +0100

libfiu (0.96-3) unstable; urgency=medium

  * Update Vcs-* to point to salsa.debian.org.
  * Bump Standards-Version to 4.1.4

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Jun 2018 17:52:39 +0100

libfiu (0.96-2) unstable; urgency=medium

  * Apply patch from upstream to make the build reproducible. (Closes: #894776)

 -- Chris Lamb <lamby@debian.org>  Wed, 04 Apr 2018 09:36:48 +0100

libfiu (0.96-1) unstable; urgency=medium

  * New upstream release. (Closes: #893049)
    - Fix FTBFS due to build/test parellelism. (Closes: #893049)
  * Add explicit python3-distutils Build-Dependency.

 -- Chris Lamb <lamby@debian.org>  Sun, 25 Mar 2018 20:32:20 -0400

libfiu (0.95-7) unstable; urgency=medium

  * Drop debian/patches/0001-ALso-preload-libfiu.so-explicitly.patch; it does
    not actually fix #893049 -- something else/strange is going on.

 -- Chris Lamb <lamby@debian.org>  Sat, 17 Mar 2018 18:38:49 -0400

libfiu (0.95-6) unstable; urgency=medium

  * LD_PRELOAD libfiu.so explicitly to avoid test failure. (Closes: #893049)

 -- Chris Lamb <lamby@debian.org>  Thu, 15 Mar 2018 19:05:21 -0700

libfiu (0.95-5) unstable; urgency=medium

  * Update Build-Depends for cross-compilation. Thanks to Helmut Grohne for
    the patch. (Closes: #892946)
  * Add gbp.conf.
  * Use .travis.yml from travis.debian.net.
  * Update debian/watch to use HTTPS URI.
  * wrap-and-sort -sa.

 -- Chris Lamb <lamby@debian.org>  Wed, 14 Mar 2018 12:16:55 -0700

=== debian/control ===
--- 
+++ 
@@ -3,21 +3,24 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 11~),
  dh-python,
- python-all-dev,
+ libpython-all-dev,
+ libpython3-all-dev,
+ python-all-dev:any,
  python-docutils,
- python3-all-dev
-Standards-Version: 3.9.8
-Homepage: http://blitiri.com.ar/p/libfiu/
-Vcs-Git: https://github.com/lamby/pkg-libfiu
-Vcs-Browser: https://github.com/lamby/pkg-libfiu
+ python3-distutils,
+ python3-all-dev:any,
+Standards-Version: 4.1.4
+Homepage: https://blitiri.com.ar/p/libfiu/
+Vcs-Git: https://salsa.debian.org/lamby/pkg-libfiu.git
+Vcs-Browser: https://salsa.debian.org/lamby/pkg-libfiu
 
 Package: libfiu0
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: userspace fault injection framework
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -32,7 +35,7 @@
 Depends:
  libfiu0 (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: userspace fault injection framework (utilities)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -46,7 +49,7 @@
 Depends:
  libfiu0 (= ${binary:Version}),
  ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: userspace fault injection framework (development libraries)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -62,7 +65,7 @@
  libfiu0 (= ${binary:Version}),
  ${misc:Depends},
  ${python:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: userspace fault injection framework (Python bindings)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to
@@ -77,7 +80,7 @@
  libfiu0 (= ${binary:Version}),
  ${misc:Depends},
  ${python3:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
 Description: userspace fault injection framework (Python 3 bindings)
  libfiu is a C library for fault injection. It provides functions to mark
  "points of failure" inside your code (the "core API"), and functions to

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 	dh_auto_test -- V=1 LC_ALL=C
 
 override_dh_auto_install:
-	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu
+	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu V=1
 	cd bindings/python && \
 	set -e && for i in $(PYTHON2_VERSIONS); do \
 	  python$$i ./setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb; \

## libfiu 0.98

=== libfiu/Makefile ===
--- 
+++ 
@@ -38,7 +38,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.96
+LIB_VER=0.98
 LIB_SO_VER=0

=== tests/Makefile ===
--- 
+++ 
@@ -13,12 +13,15 @@
 
 ifneq ($(V), 1)
 	NICE_CC = @echo "  CC  $@"; $(CC)
-	NICE_RUN = @echo "  RUN $<"; LD_LIBRARY_PATH=../libfiu/
+	NICE_RUN = @echo "  RUN $<"; \
+		   LD_LIBRARY_PATH=../libfiu/ \
+		   LD_PRELOAD=./libs/fiu_run_preload.so:./libs/fiu_posix_preload.so
 	NICE_PY = @echo "  PY  $<"; ./wrap-python 2
 	NICE_LN = @echo "  LN $@"; ln -f
 else
 	NICE_CC = $(CC)
-	NICE_RUN = LD_LIBRARY_PATH=../libfiu/
+	NICE_RUN = LD_LIBRARY_PATH=../libfiu/ \
+		   LD_PRELOAD=./libs/fiu_run_preload.so:./libs/fiu_posix_preload.so
 	NICE_PY = ./wrap-python 2
 	NICE_LN = ln -f
 endif
@@ -67,7 +70,7 @@
 	$(NICE_CC) $(ALL_CFLAGS) \
 		-rdynamic -fno-optimize-sibling-calls $< -lfiu -lpthread -o $@
 
-c-run-%: %
+c-run-%: % lnlibs
 	$(NICE_RUN) ./$<
 
 
@@ -120,6 +123,8 @@
 	rm -rf libs/ small-cat
 	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
 	$(MAKE) -C generated clean
+	$(MAKE) -C collisions clean
+	$(MAKE) -C utils clean
 
 FORCE:

=== preload/posix/Makefile ===
--- 
+++ 
@@ -81,8 +81,12 @@
 # ia64 and alpha use libc.so.6.1), so find which one to use at build-time.
 # Please note that the argument to ldd *must* start with "./", otherwise some
 # "ldd"s won't work (for example, the one in FreeBSD 8.1).
+# To find out the soname, we build a dummy shared library against the libc,
+# and use ldd to extract the version. This shared library must actually use
+# something from libc, otherwise a smart compiler/linker (such as one using
+# --as-needed) might not link it against libc.
 build-libcsoname:
-	@$(CC) -x c /dev/null -lc -shared -o build-libccheck.so
+	@$(CC) build-libccheck.c -lc -shared -fPIC -o build-libccheck.so
 	@ldd ./build-libccheck.so | grep libc.so | awk '{ print $$1 }' > $@
 	@rm build-libccheck.so
 	@test "`cat $@`" != "" || \
@@ -94,17 +98,16 @@
 		> build-env.h
 
 
-fiu_posix_preload.so: build-flags build-env.h build-needlibdl $(OBJS)
-	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) \
+fiu_posix_preload.so: build-flags build-env.h build-needlibdl \
+		$(OBJS) ../../libfiu/hash.c
+	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) ../../libfiu/hash.c \
 		-L../../libfiu/ \
 		-lfiu `cat build-needlibdl` \
 		-o fiu_posix_preload.so
 
 
-# this should only be needed when building the function list and not the
-# preload library
-%.mod.fl: %.mod
-	$(NICE_GEN) $< $<.c $@
+# A module's function list gets generated with the .c file.
+%.mod.fl: %.mod.c ;
 
 function_list: $(GEN_FL) function_list.in
 	@echo "  function_list"

=== preload/run/Makefile ===

CFLAGS += -std=c99 -Wall -O3
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
		-I. -I../../libfiu/ $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

# prefix for installing the binaries
PREFIX=/usr/local

# location of preload libraries
PLIBPATH=$(PREFIX)/lib

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


OBJS = run.o


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
else
	NICE_CC = $(CC)
endif


default: all
	
all: fiu_run_preload.so fiu-run

BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

$(OBJS): build-flags

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@


# some platforms do not have libdl, we only use it if available
build-needlibdl:
	@$(LD) -ldl -o dlcheck.so 2>/dev/null \
		&& echo -ldl > $@ || echo > $@
	@rm -f dlcheck.so


fiu_run_preload.so: build-flags build-needlibdl $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $(OBJS) \
		-L../../libfiu/ \
		-lfiu `cat build-needlibdl` \
		-o fiu_run_preload.so


fiu-run: build-flags fiu-run.in
	cat fiu-run.in | sed "s+@@PLIBPATH@@+$(PLIBPATH)+g" > fiu-run
	chmod +x fiu-run

install: fiu_run_preload.so fiu-run
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 fiu_run_preload.so $(PREFIX)/lib
	$(INSTALL) -d $(PREFIX)/bin
	$(INSTALL) -m 0755 fiu-run $(PREFIX)/bin
	$(INSTALL) -d $(PREFIX)/share/man/man1
	$(INSTALL) -m 0644 fiu-run.1 $(PREFIX)/share/man/man1/

uninstall:
	$(RM) $(PREFIX)/lib/fiu_run_preload.so
	$(RM) $(PREFIX)/bin/fiu-run
	$(RM) $(PREFIX)/share/man/man1/fiu-run.1

clean:
	rm -f $(OBJS) fiu_run_preload.so fiu-run build-flags
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out
	rm -f build-needlibdl

.PHONY: default install uninstall clean .force-build-flags

=== debian/changelog ===
libfiu (0.98-2) unstable; urgency=medium

  * Honour CPPFLAGS and LDFLAGS when building shared libraries to ensure
    hardening is applied to generated objects.
  * Add patch from upstream to avoid the use of PATH_MAX for GNU Hurd.
  * debian/rules:
    - Indent consistently.
    - Enable hardening build flags.
  * debian/control:
    - Move to Standards-Version 4.3.0.
    - Move to debhelper-compat level 12.

 -- Chris Lamb <lamby@debian.org>  Tue, 08 Jan 2019 08:21:43 +0100

libfiu (0.98-1) unstable; urgency=medium

  * New upstream release.
    - Drop patches; applied upstream.
  * Add "Build-Depends-Package" field to the symbols file.

 -- Chris Lamb <lamby@debian.org>  Thu, 13 Dec 2018 23:12:37 +0100

libfiu (0.97-2) unstable; urgency=medium

  * Mangle the return offset size for 64-bit variants too to prevent FTBFS on
    32-bit architectures. (Closes: #911733)

 -- Chris Lamb <lamby@debian.org>  Wed, 24 Oct 2018 23:17:19 -0400

libfiu (0.97-1) unstable; urgency=medium

  * New upstream release.
    - Drop all patches; applied upstream.
    - Update debian/symbols.
  * Use debhelper-compat (= 11) build-dependency and drop debian/compat.

 -- Chris Lamb <lamby@debian.org>  Tue, 23 Oct 2018 19:27:05 -0400

libfiu (0.96-5) unstable; urgency=medium

  * Apply patch from upstream to write fiu_ctrl.py atomically to avoid FTBFS
    when building in parallel. (Closes: #909843)
  * Bump Standards-Version to 4.2.1.

 -- Chris Lamb <lamby@debian.org>  Mon, 01 Oct 2018 22:04:49 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 12),
  dh-python,
  libpython-all-dev,
  libpython3-all-dev,
@@ -11,7 +11,7 @@
  python-docutils,
  python3-distutils,
  python3-all-dev:any,
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Homepage: https://blitiri.com.ar/p/libfiu/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-libfiu.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-libfiu

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
PYTHON2_VERSIONS := $(shell pyversions -sv)
PYTHON3_VERSIONS := $(shell py3versions -sv)
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3,python2

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build -- V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON2_VERSIONS); do \
		python$$i ./setup.py build; \
	done
	cd bindings/python && \
	set -e && for i in $(PYTHON3_VERSIONS); do \
		python$$i ./setup.py build; \
	done

override_dh_auto_test:
	dh_auto_test -- V=1 LC_ALL=C

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON2_VERSIONS); do \
		python$$i ./setup.py install --root=$(CURDIR)/debian/python-fiu --no-compile -O0 --install-layout=deb; \
	done
	cd bindings/python && \
	set -e && for i in $(PYTHON3_VERSIONS); do \
		python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst

=== debian/tests/control ===
Tests: 0001-fiu-run-nonblocking

Tests: 0002-fiu-run-blocking
Restrictions: allow-stderr

Tests: 0003-python2

Tests: 0004-python3

## libfiu 1.00

=== Makefile ===


default: all

install: all_install

uninstall: all_uninstall

all: libfiu preload utils

all_install: libfiu_install preload_install utils_install

all_uninstall: libfiu_uninstall preload_uninstall utils_uninstall


libfiu:
	$(MAKE) -C libfiu

libfiu_clean:
	$(MAKE) -C libfiu clean

libfiu_install:
	$(MAKE) -C libfiu install

libfiu_uninstall:
	$(MAKE) -C libfiu uninstall


preload: libfiu
	$(MAKE) -C preload

preload_clean:
	$(MAKE) -C preload clean

preload_install: preload
	$(MAKE) -C preload install

preload_uninstall:
	$(MAKE) -C preload uninstall


utils:
	$(MAKE) -C utils

utils_clean:
	$(MAKE) -C utils clean

utils_install: utils
	$(MAKE) -C utils install

utils_uninstall:
	$(MAKE) -C utils uninstall


tests: test

test: libfiu bindings preload
	$(MAKE) -C tests

test_clean:
	$(MAKE) -C tests clean


bindings: python2 python3

bindings_install: python2_install python3_install

bindings_clean: python_clean

python2: libfiu
	cd bindings/python && python setup.py build

python2_install: python2
	cd bindings/python && python setup.py install

python3: libfiu
	cd bindings/python && python3 setup.py build

python3_install: python3
	cd bindings/python && python3 setup.py install

python_clean:
	cd bindings/python && rm -rf build/ fiu_ctrl.py


clean: python_clean preload_clean libfiu_clean utils_clean test_clean


.PHONY: default all clean install all_install uninstall all_uninstall \
	libfiu libfiu_clean libfiu_install libfiu_uninstall \
	python2 python2_install python3 python3_install python_clean \
	bindings bindings_install bindings_clean \
	preload preload_clean preload_install preload_uninstall \
	utils utils_clean utils_install utils_uninstall \
	test tests test_clean

=== libfiu/Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 
 CFLAGS += -std=c99 -pedantic -Wall
-ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 $(CFLAGS)
+ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
+		$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
 
 # Optimization CFLAGS, only used when doing a non-debug build.
 OPT_CFLAGS = -O3
@@ -38,7 +39,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=0.98
+LIB_VER=1.00
 LIB_SO_VER=0

=== tests/Makefile ===
--- 
+++ 
@@ -16,13 +16,13 @@
 	NICE_RUN = @echo "  RUN $<"; \
 		   LD_LIBRARY_PATH=../libfiu/ \
 		   LD_PRELOAD=./libs/fiu_run_preload.so:./libs/fiu_posix_preload.so
-	NICE_PY = @echo "  PY  $<"; ./wrap-python 2
+	NICE_PY = @echo "  PY  $<"; ./wrap-python 3
 	NICE_LN = @echo "  LN $@"; ln -f
 else
 	NICE_CC = $(CC)
 	NICE_RUN = LD_LIBRARY_PATH=../libfiu/ \
 		   LD_PRELOAD=./libs/fiu_run_preload.so:./libs/fiu_posix_preload.so
-	NICE_PY = ./wrap-python 2
+	NICE_PY = ./wrap-python 3
 	NICE_LN = ln -f
 endif

=== utils/Makefile ===

# prefix for installing the binaries
PREFIX=/usr/local

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


default:
	
install:
	$(INSTALL) -d $(PREFIX)/bin
	$(INSTALL) -m 0755 fiu-ctrl $(PREFIX)/bin
	$(INSTALL) -m 0755 fiu-ls $(PREFIX)/bin
	$(INSTALL) -d $(PREFIX)/share/man/man1
	$(INSTALL) -m 0644 fiu-ctrl.1 $(PREFIX)/share/man/man1/
	$(INSTALL) -m 0644 fiu-ls.1 $(PREFIX)/share/man/man1/

uninstall:
	$(RM) $(PREFIX)/bin/fiu-ctrl
	$(RM) $(PREFIX)/bin/fiu-ls
	$(RM) $(PREFIX)/share/man/man1/fiu-ctrl.1
	$(RM) $(PREFIX)/share/man/man1/fiu-ls.1

clean:

.PHONY: default install uninstall clean

=== preload/posix/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 CFLAGS += -std=c99 -Wall -O3
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
 		-D_LARGEFILE64_SOURCE=1 -I. -I../../libfiu/ \
-		$(CFLAGS)
+		$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
 
 ifdef DEBUG
 ALL_CFLAGS += -g

=== debian/changelog ===
libfiu (1.00-7) unstable; urgency=medium

  * Fix FTBFS on amd64 with Python 3.8. Thanks, Alberto. (Closes: #954287)
  * Bump Standards-Version to 4.5.0.

 -- Chris Lamb <lamby@debian.org>  Sat, 28 Mar 2020 23:11:55 +0000

libfiu (1.00-6) unstable; urgency=medium

  * Drop Build-Depends on libpython-all-dev for Python 2.x removal. Thanks,
    Sandro Tosi. (Closes: #936856)

 -- Chris Lamb <lamby@debian.org>  Sun, 19 Jan 2020 09:29:59 +0000

libfiu (1.00-5) unstable; urgency=medium

  * Don't run the non-deterministic "parallel" and "parallel-wildcard" tests.

 -- Chris Lamb <lamby@debian.org>  Sat, 28 Dec 2019 16:31:00 +0000

libfiu (1.00-4) unstable; urgency=medium

  * Don't FTBFS when multiple Python version libraries exist in build tree by
    manually deleting all but the version for the default Python version
    returned by py3versions prior to running the test suite. (Closes: #944911)
  * Specify Rules-Requires-Root: no.
  * Bump Standards-Version to 4.4.1.

 -- Chris Lamb <lamby@debian.org>  Sat, 23 Nov 2019 17:26:03 -0500

libfiu (1.00-3) unstable; urgency=medium

  * Patch the upstream Makefile to not build the Python 2.x bindings to ensure
    the tests pass.

 -- Chris Lamb <lamby@debian.org>  Tue, 10 Sep 2019 11:45:27 +0100

libfiu (1.00-2) unstable; urgency=medium

  * Drop Python 2.x support in the autopkgtests.

 -- Chris Lamb <lamby@debian.org>  Tue, 10 Sep 2019 11:00:10 +0100

libfiu (1.00-1) unstable; urgency=medium

  * New upstream release.
    - Drop all patches; applied upstream.
  * Drop Python 2.x packages. (Closes: #936856)
  * Register HTML documentation with doc-base.
  * Update Lintian overrides:
    - Override pkg-config-unavailable-for-cross-compilation Lintian warning for
      usr/lib/pkgconfig/libfiu.pc; the library is for runtime fault injection
      and thus cross-compilation is not a use-case.
    - Drop misnamed and thus unused debian/libfiu.lintian.override.
  * Drop debian/source/options.
  * Bump Standards-Version to 4.4.0.

 -- Chris Lamb <lamby@debian.org>  Tue, 10 Sep 2019 10:30:40 +0100

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
 Build-Depends:
  debhelper-compat (= 12),
  dh-python,
- libpython-all-dev,
  libpython3-all-dev,
- python-all-dev:any,
- python-docutils,
+ python3-docutils,
  python3-distutils,
  python3-all-dev:any,
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://blitiri.com.ar/p/libfiu/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-libfiu.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-libfiu
+Rules-Requires-Root: no
 
 Package: libfiu0
 Architecture: any
@@ -58,21 +57,6 @@
  This package contains the development libraries and documentation in HTML and
  reStructuredText formats.
 
-Package: python-fiu
-Section: python
-Architecture: any
-Depends:
- libfiu0 (= ${binary:Version}),
- ${misc:Depends},
- ${python:Depends},
- ${shlibs:Depends},
-Description: userspace fault injection framework (Python bindings)
- libfiu is a C library for fault injection. It provides functions to mark
- "points of failure" inside your code (the "core API"), and functions to
- enable/disable the failure of those points (the "control API").
- .
- This package contains Python bindings to libfiu.
-
 Package: python3-fiu
 Section: python
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
PYTHON_VERSIONS := $(shell py3versions -sv)
PYTHON_VERSION_DEFAULT := $(shell py3versions -dv)
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3

clean:
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build -- V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON_VERSIONS); do \
		python$$i ./setup.py build; \
	done

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	find bindings/python/build \
		-maxdepth 1 \
		-type d \
		-not -name '*$(PYTHON_VERSION_DEFAULT)*' -print0 | \
		xargs -0r rm -rvf
	# Remove non-deterministic tests
	rm -fv tests/test-parallel.c tests/test-parallel-wildcard.c
	dh_auto_test -- V=1 LC_ALL=C
endif

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON_VERSIONS); do \
		python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst

=== debian/watch ===
version=3
https://blitiri.com.ar/p/libfiu/ files/[^/]+/libfiu-(.*).tar.gz

## libfiu 1.1

=== Makefile ===
--- 
+++ 
@@ -61,17 +61,17 @@
 	$(MAKE) -C tests clean
 
 
-bindings: python2 python3
+bindings: python3
 
-bindings_install: python2_install python3_install
+bindings_install: python3_install
 
 bindings_clean: python_clean
 
 python2: libfiu
-	cd bindings/python && python setup.py build
+	cd bindings/python && python2 setup.py build
 
 python2_install: python2
-	cd bindings/python && python setup.py install
+	cd bindings/python && python2 setup.py install
 
 python3: libfiu
 	cd bindings/python && python3 setup.py build

=== libfiu/Makefile ===
--- 
+++ 
@@ -39,7 +39,7 @@
 	NICE_CC = $(CC)
 endif
 
-LIB_VER=1.00
+LIB_VER=1.1
 LIB_SO_VER=0

=== libfiu/doxygen/Makefile ===

ifneq ($(V), 1)
        NICE_DOXYGEN = @echo "  DOXYGEN  $@"; doxygen
else
        NICE_DOXYGEN = doxygen
endif


default: all

all: public internal

# $(LIB_VER) must be defined externally if we want the generated docs to
# specify a version number. Usually, this Makefile will be invoked by
# libfiu's, which has that variable properly defined.
Doxyfile.base: Doxyfile.base.in
	@echo "generating Doxyfile.base"
	@cat Doxyfile.base.in | \
		sed 's@++VERSION++@$(LIB_VER)@g' \
		> Doxyfile.base

public: Doxyfile.base
	$(NICE_DOXYGEN) Doxyfile.public

internal: Doxyfile.base
	$(NICE_DOXYGEN) Doxyfile.internal

clean:
	rm -rf doc.internal doc.public Doxyfile.base


.PHONY: all clean default doxygen internal public

=== preload/run/Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 
 CFLAGS += -std=c99 -Wall -O3
 ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
-		-I. -I../../libfiu/ $(CFLAGS)
+		-I. -I../../libfiu/ \
+		$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)
 
 ifdef DEBUG
 ALL_CFLAGS += -g

=== tests/collisions/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall
ALL_CFLAGS = -I../../libfiu/ -L../../libfiu/ -L./ \
	-D_XOPEN_SOURCE=600 -D_GNU_SOURCE -fPIC -DFIU_ENABLE=1 $(CFLAGS)

ifdef DEBUG
ALL_CFLAGS += -g
endif

ifdef PROFILE
ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
endif

ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
	NICE_RUN = @echo "  RUN $<"; \
		   LD_LIBRARY_PATH="./:../../libfiu/"
	NICE_LN = @echo "  LN $@"; ln -f
else
	NICE_CC = $(CC)
	NICE_RUN = LD_LIBRARY_PATH="./:../../libfiu/"
	NICE_LN = ln -f
endif

default: tests

all: tests


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi

#
# Test library and binaries.
#

libcoltest.so: libcoltest.c libcoltest.h
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC $< -o $@

binary: binary.c libcoltest.so
	$(NICE_CC) $(ALL_CFLAGS) -L. $< -lfiu -lcoltest -o $@


tests: binary
	$(NICE_RUN) ./binary

#
# Cleanup
#

clean:
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
	rm -f libcoltest.so binary

FORCE:

.PHONY: default all clean \
	tests c-tests py-tests \
	.force-build-flags

=== tests/utils/Makefile ===
--- 
+++ 
@@ -44,7 +44,6 @@
 
 clean:
 	rm -f libs/*.so output-*.txt
-	rmdir libs/
 
 .PHONY: default all clean \
 	tests lnlibs

=== debian/changelog ===
libfiu (1.1-3) unstable; urgency=medium

  [ Chris Lamb ]
  * Apply patch from upstream to prevent compiler from inlining stack test
    functions which was causing an FTBFS when Link-Time Optimisation (LTO) was
    enabled. (Closes: #1015487)
  * Update copyright years in debian/copyright.
  * Update debian/gitlab-ci.yml.
    - Allow blhc failures for now.
    - Try and ensure all dpkg-buildflags are passed.
  * Bump Standards-Version to 4.6.1.

  [ Debian Janitor ]
  * Update watch file format version to 4.

 -- Chris Lamb <lamby@debian.org>  Mon, 29 Aug 2022 08:56:13 +0100

libfiu (1.1-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Update watch file format version to 4.

  [ Chris Lamb ]
  * Update debian/gitlab-ci.yml.
  * Try and ensure all dpkg-buildflags are passed.
  * Allow blhc failures for now.
  * Apply patch from upstream to prevent compiler from inlining stack test functions which was causing an FTBFS when Link-Time Optimisation (LTO) was enabled. (Closes: #1015487)
  * Bump Standards-Version to 4.6.1.
  * Update copyright years in debian/copyright.

 -- Chris Lamb <lamby@debian.org>  Mon, 29 Aug 2022 08:56:09 +0100

libfiu (1.1-1) unstable; urgency=medium

  * New upstream release.
  * Install docs directly into /usr/share/doc/libfiu-dev, not in a doc/
    subdirectory.
  * Drop 0001-Don-t-build-Python-2.x-bindings-used-in-tests.patch; Python 2
    support dropped upstream.
  * Drop 0002-bindings-python-Increment-refcount-on-failinfo-objec.patch;
    applied upstream.
  * Bump Standards-Version to 4.6.0.
  * Rename a lintian tag.

 -- Chris Lamb <lamby@debian.org>  Sat, 27 Nov 2021 10:00:13 -0800

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  dh-python,
  libpython3-all-dev,
+ python3-all-dev:any,
+ python3-distutils,
  python3-docutils,
- python3-distutils,
- python3-all-dev:any,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Homepage: https://blitiri.com.ar/p/libfiu/
 Vcs-Git: https://salsa.debian.org/lamby/pkg-libfiu.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-libfiu

=== debian/rules ===
--- 
+++ 
@@ -19,7 +19,7 @@
 	rst2html $< > $@
 
 override_dh_auto_build: $(DOCS)
-	dh_auto_build -- V=1
+	dh_auto_build -- V=1 $(shell dpkg-buildflags --export=cmdline)
 	cd bindings/python && \
 	set -e && for i in $(PYTHON_VERSIONS); do \
 		python$$i ./setup.py build; \
